

WORKING_DIR=/RouletteMaster/EMPTY_DATABASE/
GFIX=/opt/firebird/bin/gfix
ISQL=/opt/firebird/bin/isql
DATABASE_FILE=/data/ROULETTE_DATA.GDB

cd $WORKING_DIR

#ce vraca 0, so napake, ce vraca 1 je ok.
echo Checking database consistency - simple validation - Test1
$GFIX -v $DATABASE_FILE -user sysdba -password masteraloha|grep errors
if [ $? -eq 0 ]; then
	echo "Test1 FAILED: Database corruption detected on simple validation"
	echo Database needs service, running repair_db_level1.sh
	$WORKING_DIR/loop_play.sh $WORKING_DIR/piano.wav &
		$WORKING_DIR/repair_db_level1.sh
	killall loop_play.sh
	killall aplay
	exit 1
else
    echo "Test1 OK"
fi


echo Checking database consistency - full validation - Test2
$GFIX -v -f $DATABASE_FILE -user sysdba -password masteraloha |grep errors
if [ $? -eq 0 ]; then
	echo "Test2 FAILED: Database corruption detected on full validation"
	echo Database needs service, running repair_db_level1.sh
	$WORKING_DIR/loop_play.sh $WORKING_DIR/piano.wav &
		$WORKING_DIR/repair_db_level1.sh
	killall loop_play.sh
	killall aplay
	exit 1
else
    echo "Test2 OK"
fi


#test za transaction limit reached
#ce vraca 0 je ok, ce vraca 1 je najbrz transaction limit reached
echo Checking database for transaction limit - Test3
echo "select first 1 ATTR_NAME from CONFIGURATION;" | $ISQL $DATABASE_FILE -user sysdba -password masteraloha | grep ATTR_NAME 2>&1 1>/dev/null
if [ $? -ne 0 ]; then
	echo "Test3 FAILED: Can not execute test SQL, maybe transaction limit reached on database"
	echo Database needs service, running repair_db_level1.sh
	$WORKING_DIR/loop_play.sh $WORKING_DIR/piano.wav &
		$WORKING_DIR/repair_db_level1.sh
	killall loop_play.sh
	killall aplay
	exit 1
else
    echo "Test3 OK"
fi

echo Database tests successfuly completed with NO ERRORS.
