#!/bin/bash
echo
echo "Starting Database repair LEVEL 1 on `cat /RouletteMaster/ROULETTE_NAME` /data/ROULETTE_DATA.GDB"
echo "Press CTRL+C to cancel now...."
sleep 5
echo "Started...please wait(this process may last up to 30 minutes)."
echo "!!!DO NOT INTERRUPT THIS PROCESS!!!"

service crond stop > /dev/null 2>&1
service roulette stop > /dev/null 2>&1
sleep 7
service firebird stop > /dev/null 2>&1
sleep 3
killall fbserver > /dev/null 2>&1

rm -rf /data/TEMPDB.GDB > /dev/null 2>&1
rm -rf /data/TEMPBKP.GBK > /dev/null 2>&1

cp -a /data/ROULETTE_DATA.GDB /data/TEMPDB.GDB > /dev/null 2>&1

#nekod so nagajale pravice, zato jih dodamo za vsak slucaj
chown firebird:firebird /data/TEMPDB.GDB
chmod 666 /data/TEMPDB.GDB
chmod ugo+rw /data

if [ $? -ne 0 ]; then
#error
    echo "ERROR: Error copying to TEMPDB.GDB"
    exit 1
fi
echo "Mirror database created.."

service firebird start > /dev/null 2>&1
sleep 2

#creating backup
/opt/firebird/bin/gfix -mode read_only /data/TEMPDB.GDB -user sysdba -password masteraloha
/opt/firebird/bin/gfix -v /data/TEMPDB.GDB -user sysdba -password masteraloha
/opt/firebird/bin/gfix -v -f /data/TEMPDB.GDB -user sysdba -password masteraloha
/opt/firebird/bin/gfix -mend /data/TEMPDB.GDB -user sysdba -password masteraloha
/opt/firebird/bin/gbak -b -g /data/TEMPDB.GDB /data/TEMPBKP.GBK -user sysdba -password masteraloha
if [ $? -ne 0 ]; then
#error
    echo "ERROR: Error creating backup."
    exit 2
else
#ok
    echo "Backup created successfully."
fi

#restoring from backup
rm -rf /data/TEMPDB.GDB > /dev/null 2>&1
/opt/firebird/bin/gbak -Z 2>&1 | grep "Firebird 2.5" >/dev/null
if [ $? -ne 0 ]; then #FIREBIRD KI NE PODPIRA FIX_FSS_METADATA
    /opt/firebird/bin/gbak -c /data/TEMPBKP.GBK /data/TEMPDB.GDB -user sysdba -password masteraloha 
else
    /opt/firebird/bin/gbak -c /data/TEMPBKP.GBK /data/TEMPDB.GDB -user sysdba -password masteraloha -FIX_FSS_METADATA WIN1250 -FIX_FSS_DATA WIN1250
fi 
if [ $? -ne 0 ]; then
    echo "ERROR: Error restoring from backup."
    exit 3
else
    echo "Backup restored successfully."
fi

#set restored database back to read-write
/opt/firebird/bin/gfix -mode read_write /data/TEMPDB.GDB -user sysdba -password masteraloha

#set perimissions
chown firebird:firebird /data/TEMPDB.GDB
chmod 666 /data/TEMPDB.GDB

service firebird stop > /dev/null 2>&1
sleep 10
killall fbserver > /dev/null 2>&1

cp /data/ROULETTE_DATA.GDB `mktemp /data/ROULETTE_DATA.XXX`
if [ $? -ne 0 ]; then
    echo "ERROR: Error copying to ROULETTE_DATA.XXX"
    exit 1
fi
mv /data/TEMPDB.GDB /data/ROULETTE_DATA.GDB
if [ $? -ne 0 ]; then
    echo "ERROR: Error copying to ROULETTE_DATA.GDB"
    exit 1
fi
echo "New database was created successfully."

service firebird start
service crond start
rm -rf /data/TEMPDB.GDB
rm -rf /data/TEMPBKP.GBK
echo
echo "All task were completed. If the problem still persist try repairing
with repair_db_level2.sh"
echo
echo "DB REPAIR LEVEL1 was finished successfully."
echo
sleep 5

exit 0


